Subject: Re: bug#46414: 27.1; remove-hook doesn't remove entries from hook--depth-alist
From: <[email-masked]>
To: Lars Ingebrigtsen <[email-masked]>
Cc: [email-masked]
Date: Thu, 16 Jun 2022 16:18:55 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

Lars Ingebrigtsen <[email-masked]> writes:

> jakanakaevangeli <[email-masked]> writes:
>
>> add-hook can add an entry to the hook symbol's hook--depth-alist
>> property and remove-hook doesn't remove it. This means that for each
>> call to eval-after-load, after-load-functions' hook--depth-alist gets a
>> new element when the feature is loaded, which can hinder performance.
>>
>> This can also cause problems if your completing-read-function uses
>>
>>     (minibuffer-with-setup-hook (:append generated-function-symbol)
>>       (read-from-minibuffer ...))
>>
>> This will add a new element to minibuffer-setup-hook's the depth alist
>> for each completing-read session (such is the case when using
>> selectrum.el [1] completion function).
>
> (I'm going through old bug reports that unfortunately weren't resolved
> at the time.)
>
> The test case here isn't complete, so I can't test whether the problem
> is still present.  I think it might have been fixed by:
>
> commit 4bd7963e2e244ace94afa59124f2637543d74ba2
> Author:     Stefan Monnier <[email-masked]>
> AuthorDate: Tue Feb 22 10:18:43 2022 -0500
>
>     (add-hook, remove-hook): Fix leaks (bug#48666)
>     
>     * lisp/subr.el (add-hook, remove-hook): Rewrite the hook depth
>     management so we only keep the info relevant to functions present on
>     the hook.
>
> Do you still see this problem in Emacs 29?
>
> -- 
> (domestic pets only, the antidote for overdose, milk.)
>    bloggy blog: http://lars.ingebrigtsen.no

Yep it was fixed by this commit and also the related

commit db92e83797bf2f1af4e0b0383283a49968746b51
Author: Stefan Monnier <[email-masked]>
Date:   Fri Apr 23 16:50:12 2021 -0400

    * lisp/subr.el (add-hook): Try and fix bug#46326
    
    Use `eq` indexing on `hook--depth-alist`.
    
    (remove-hook): Remove old entries from `hook--depth-alist`.

Thanks.